#!/usr/bin/perl

use IO::Select;
use Digest::MD5;

sub sig_pipe {
  exit 141;
}

$SIG{PIPE} = \&sig_pipe;

if (length(@ARGV) ne 1) {
  exit 1;
}

# Open our named pipe in binary mode
open($handle, "$ARGV[0]") or die "can't open $ARGV[0]: $!";
binmode($handle);

# create a new Select object
$s = IO::Select->new($handle);
$i=0;

$md = Digest::MD5->new;

#$t=time();
# Wait for up to 30 seconds for data
while (@ready = $s->can_read(15*60)) {
  foreach $fh (@ready) {
    if ($fh == $handle) {
      # read from the named pipe
      my $c=sysread($handle, $buff, 8 * 2**10);

      # if there is no data remove it from the select
      if (not defined $c or not $c) {
        $s->remove($fh);
      } else {
        print STDOUT $buff;
        $md->add($buff);
      }

#      $tnew=time();
#      $tdiff=$tnew-$t;
#      $t=$tnew;
#      if ($tdiff > 30) {
#        print STDERR "$i $tdiff\n";
#      }
#      $i++;
    } else {
      # this shouldn't happen. only $handle is selectable
      $s->remove($fh);
    }
  }
}
print STDERR $md->hexdigest, "\n";
close($handle);
