#!/usr/bin/expect -f
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2009, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

# argv 0 userid
# argv 1 remote hostname
# argv 2 passwd
# argv 3 input
# argv 4 output

#system "echo argv [string length $argv]\n"
#system "echo  0 = [lindex $argv 0]\n"
#system "echo  1 = [lindex $argv 1]\n"
#system "echo  2 = [lindex $argv 2]\n"
#system "echo  3 = [lindex $argv 3]\n"

set SRCDIR /mnt/HostVG/vmsnapshot
log_user 0

spawn bash

set prompt "(%|#|\\\$) $"
catch {set prompt $env(EXPECT_PROMPT)}

# set the time out 2 mins for promote password
set timeout 120
send -- "ssh -T -o StrictHostKeyChecking=no -o PubkeyAuthentication=no [lindex $argv 0]@[lindex $argv 1] \"exec 0<&- 2>&-;trap 'exec 1>&-;exit;' 1 2 3 6 15 17 25; sleep 20; cat [lindex $argv 4];exec 1>&-;exit\" > [lindex $argv 3] \r"

while 1 {
	expect {
		timeout {
		# if password is not promoted for 10 mins, exit 1
		exit 1
		}
		-re "yes/no" {
  			send  "yes\r"
 		} 
		-re "assword:" {
   			send  "[lindex $argv 2]\r"
			break
 		}
		-re "out" {
		# connection timed out
			exit 1
		}
		-re "route" {
		# no route to host
			exit 1
		}
	}
}

# set the time out 10 hours for sftp transfer
set timeout 36000
expect {

	timeout {
		exit 1
	}
	eof {
		send -- "echo $?\r"
	} 
	"#" {
		send -- "echo $?\r"
	} 
	$prompt {
		send -- "echo $?\r"
	}
}

# set the time out 2 mins for echo
set timeout 120
expect -re "(\[0-9]+)\r\n"
if {[info exists expect_out] && [info exists expect_out(1,string)]} {
	exit $expect_out(1,string)
} else {
	exit 1
}
